#ifndef bqtQBlibBasFunHH
#define bqtQBlibBasFunHH

#include "stringfun.hh"

long long int BasCLNG(long double a);
long long int BasCINT(long double a);
long long int BasINT(long double a);
long long int BasMODop(long long int a, long long int b);
long double BasVAL(const std::string& s);

inline long BasCLNG(int a) { return a; }
inline long BasCLNG(unsigned a) { return a; }
inline long BasCLNG(short a) { return a; }
inline long BasCLNG(unsigned short a) { return a; }
inline long BasCLNG(unsigned char a) { return a; }
inline long BasCLNG(signed char a) { return a; }
inline long BasCLNG(long a) { return a; }
inline long long BasCLNG(unsigned long a) { return a; }
inline long long BasCLNG(long long a) { return a; }

inline int BasINT(unsigned char a) { return a; }
inline int BasINT(signed char a) { return a; }
inline int BasINT(unsigned short a) { return a; }
inline int BasINT(signed short a) { return a; }
inline int BasINT(int a) { return a; }
inline int BasCINT(unsigned char a) { return a; }
inline int BasCINT(signed char a) { return a; }
inline int BasCINT(unsigned short a) { return a; }
inline int BasCINT(signed short a) { return a; }
inline int BasCINT(int a) { return a; }

inline int BasINT(float a) { return (int)a; }

long long int BasCINT(float a) { return BasCINT( (long double)a ); }
long long int BasCLNG(float a) { return BasCLNG( (long double)a ); }
long long int BasCINT(double a) { return BasCINT( (long double)a ); }
long long int BasCLNG(double a) { return BasCLNG( (long double)a ); }

#define BasCSNG(a) (a)
#define BasCDBL(a) (a)

inline const std::string BasLTRIM(const std::string& s) { return LTrim(s); }
inline const std::string BasRTRIM(const std::string& s) { return RTrim(s); }
inline const std::string BasTRIM(const std::string& s) { return Trim(s); }
const std::string BasLCASE(const std::string& s);
const std::string BasUCASE(const std::string& s);

const std::string BasSTRs(long double a);
const std::string BasCHRs(long long int a);

const std::string BasLEFTs(const std::string& s, int count);
const std::string BasRIGHTs(const std::string& s, int count);
const std::string BasMIDs(const std::string& s, int pos, int count=-1);

#endif
