#include "gosub.hh"
#include "error.hh"

std::vector<void*> GosubStack;

void B_GOSUB_Push(void* label)
{
    GosubStack.push_back(label);
}

void* B_GOSUB_Pop()
{
    if(GosubStack.empty()) B_ERROR(3); /* RETURN WITHOUT GOSUB */

    void* ret = GosubStack.back();
    GosubStack.pop_back();
    return ret;
}
