#ifndef bqtQBlibPlayHH
#define bqtQBlibPlayHH

#include <qblib/types.hh>

extern void* PlayHandler;

extern void B_StmtPLAY(const BAS_STR& pattern);
extern void B_StmtPLAY(const BAS_STR& pattern, const BAS_STR& p2);
extern void B_StmtPLAY(const BAS_STR& pattern, const BAS_STR& p2, const BAS_STR& p3);

extern "C" {

extern void B_StmtSOUND(int freq, int duration/*PIT ticks*/);
extern void B_StmtNOISE(int mode/*0..7*/, int volume/*0..15*/, int duration/*PIT ticks*/);
/* Noise modes: 0..3 = periodic noise
 *              4..7 = white noise
 *              0,4: pitch = something
 *              1,5: pitch = something*2
 *              2,6: pitch = something*4
 *              3,7: pitch = playchannel[2].pitch
 */
/* BEEP, SOUND and PLAY are mutually exclusive. NOISE can be layered over any. */
extern void B_StmtBEEP();

}

#define ON_PLAY_GOTO(label)    PlayHandler = &&label
#define ON_PLAY_GOTO_NOWHERE() PlayHandler = 0

#endif
